## Installation
* Switch to Wildfly Modules Directory
 * For instance: `cd /opt/wildfly/modules/system/layers/base`
* Download distribution
 * `wget -O agent.tar.gz "https://se4.informatik.uni-wuerzburg.de/nexus/service/local/artifact/maven/redirect?r=snapshots&g=tools.descartes.prisma.agent.wildfly&a=tools.descartes.prisma.agent.wildfly&v=LATEST&c=dist&e=tar.gz"`
* Unzip archive
 * `tar -xzf agent.tar.gz`
* Edit configuration file `/opt/wildfly/domain/configuration/domain.xml`
 * Add extension: 
```
<extension module="prisma.agent.wildfly"/>
```
 * Add subsystem configuration to profile
```
<subsystem xmlns="urn:prisma.agent.wildfly:1.0" repository-host="[Prisma Repository Host]" repository-user="[Prisma Repository User]" repository-password="[Prisma Repository Password]" scope="application/[Application Name]">
</subsystem>
```
  * [Prisma Repository Host], [Prisma Repository User], [Prisma Repository Password] need to be replaced with the values of the repository
      * [Prisma Repository Host]: The IP of the host where the repository is running.
      * [Prisma Repository User], [Prisma Repository Password]: Values configured when setting up the RabbitMQ server of the repository.
  * [Application Name] can be any String describing the application
* Add servlet filter
  * Open WildFly Administration Webseite and open "Tools/Management Model"
  * Go to /profile=full-ha/subsystem=undertow/configuration=filter/custom-filter
      * Add new filter (name=MonitoringFilter, class=tools.descartes.prisma.agent.wildfly.interceptors.IncomingServletCallHandler, module=prisma.agent.wildfly)
  * Go to /profile=full-ha/subsystem=undertow/server=default-server/host=default-host/filter-ref
      * Add new filter-ref (name=MonitoringFilter, priority=2147483647)
* For each MySQL data source, add a statement interceptor
  * Open WildFly Administration Webseite and open "Tools/Management Model"
  * Go to /profile=full-ha/subsystem=datasources/data-source=[data source name]/connection-properties=statementInterceptors
    * Set attribute Value to "tools.descartes.prisma.agent.wildfly.interceptors.JDBCStatementInterceptor"
* Add a web service interceptor for outgoing calls
  * Go to /profile=full-ha/subsystem=webservices/client-config=Standard-Client-Config/pre-handler-chain
  * Add new endpoint configuration PrismaHandler
  * Add new 
	
